MCP Tools Reference: backupdr.googleapis.com

Tool: ListBackupPlanAssociations

Lists all BackupPlanAssociations. BPAs link a specific workload to a BackupPlan to enable protection.

The following sample demonstrate how to use curl to invoke the ListBackupPlanAssociations MCP tool.

Curl Request
                  
curl --location 'https://backupdr.googleapis.com/mcp' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
  "method": "tools/call",
  "params": {
    "name": "ListBackupPlanAssociations",
    "arguments": {
      // provide these details according to the tool's MCP specification
    }
  },
  "jsonrpc": "2.0",
  "id": 1
}'
                

Input Schema

Request message for List BackupPlanAssociation

ListBackupPlanAssociationsRequest

JSON representation
{
  "parent": string,
  "pageSize": integer,
  "pageToken": string,
  "filter": string
}
Fields
parent

string

Required. The project and location for which to retrieve backup Plan Associations information, in the format projects/{project_id}/locations/{location}. In Backup and DR, locations map to Google Cloud regions, for example us-central1. To retrieve backup plan associations for all locations, use "-" for the {location} value.

pageSize

integer

Optional. Requested page size. Server may return fewer items than requested. If unspecified, server will pick an appropriate default.

pageToken

string

Optional. A token identifying a page of results the server should return.

filter

string

Optional. Filtering results

Output Schema

Response message for List BackupPlanAssociation

ListBackupPlanAssociationsResponse

JSON representation
{
  "backupPlanAssociations": [
    {
      object (BackupPlanAssociation)
    }
  ],
  "nextPageToken": string,
  "unreachable": [
    string
  ]
}
Fields
backupPlanAssociations[]

object (BackupPlanAssociation)

The list of Backup Plan Associations in the project for the specified location.

If the {location} value in the request is "-", the response contains a list of instances from all locations. In case any location is unreachable, the response will only return backup plan associations in reachable locations and the 'unreachable' field will be populated with a list of unreachable locations.

nextPageToken

string

A token identifying a page of results the server should return.

unreachable[]

string

Locations that could not be reached.

BackupPlanAssociation

JSON representation
{
  "name": string,
  "resourceType": string,
  "resource": string,
  "backupPlan": string,
  "createTime": string,
  "updateTime": string,
  "state": enum (State),
  "rulesConfigInfo": [
    {
      object (RuleConfigInfo)
    }
  ],
  "dataSource": string,
  "backupPlanRevisionId": string,
  "backupPlanRevisionName": string,

  // Union field resource_properties can be only one of the following:
  "cloudSqlInstanceBackupPlanAssociationProperties": {
    object (CloudSqlInstanceBackupPlanAssociationProperties)
  },
  "filestoreInstanceBackupPlanAssociationProperties": {
    object (FilestoreInstanceBackupPlanAssociationProperties)
  },
  "alloydbClusterBackupPlanAssociationProperties": {
    object (AlloyDBClusterBackupPlanAssociationProperties)
  }
  // End of list of possible types for union field resource_properties.
}
Fields
name

string

Output only. Identifier. The resource name of BackupPlanAssociation in below format Format : projects/{project}/locations/{location}/backupPlanAssociations/{backupPlanAssociationId}

resourceType

string

Required. Immutable. Resource type of workload on which backupplan is applied

resource

string

Required. Immutable. Resource name of workload on which the backup plan is applied.

The format can either be the resource name (e.g., "projects/my-project/zones/us-central1-a/instances/my-instance") or the full resource URI (e.g., "https://www.googleapis.com/compute/v1/projects/my-project/zones/us-central1-a/instances/my-instance").

backupPlan

string

Required. Resource name of backup plan which needs to be applied on workload. Format: projects/{project}/locations/{location}/backupPlans/{backupPlanId}

createTime

string (Timestamp format)

Output only. The time when the instance was created.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

updateTime

string (Timestamp format)

Output only. The time when the instance was updated.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

state

enum (State)

Output only. The BackupPlanAssociation resource state.

rulesConfigInfo[]

object (RuleConfigInfo)

Output only. The config info related to backup rules.

dataSource

string

Output only. Resource name of data source which will be used as storage location for backups taken. Format : projects/{project}/locations/{location}/backupVaults/{backupvault}/dataSources/{datasource}

backupPlanRevisionId

string

Output only. The user friendly revision ID of the BackupPlanRevision.

Example: v0, v1, v2, etc.

backupPlanRevisionName

string

Output only. The resource id of the BackupPlanRevision.

Format: projects/{project}/locations/{location}/backupPlans/{backup_plan}/revisions/{revision_id}

Union field resource_properties. Properties of the protected Google Cloud resource. resource_properties can be only one of the following:
cloudSqlInstanceBackupPlanAssociationProperties

object (CloudSqlInstanceBackupPlanAssociationProperties)

Output only. Cloud SQL instance's backup plan association properties.

filestoreInstanceBackupPlanAssociationProperties

object (FilestoreInstanceBackupPlanAssociationProperties)

Output only. Filestore instance's backup plan association properties.

alloydbClusterBackupPlanAssociationProperties

object (AlloyDBClusterBackupPlanAssociationProperties)

Output only. AlloyDB cluster's backup plan association properties.

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

RuleConfigInfo

JSON representation
{
  "ruleId": string,
  "lastBackupState": enum (LastBackupState),
  "lastBackupError": {
    object (Status)
  },
  "lastSuccessfulBackupConsistencyTime": string
}
Fields
ruleId

string

Output only. Backup Rule id fetched from backup plan.

lastBackupState

enum (LastBackupState)

Output only. The last backup state for rule.

lastBackupError

object (Status)

Output only. google.rpc.Status object to store the last backup error.

lastSuccessfulBackupConsistencyTime

string (Timestamp format)

Output only. The point in time when the last successful backup was captured from the source.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Status

JSON representation
{
  "code": integer,
  "message": string,
  "details": [
    {
      "@type": string,
      field1: ...,
      ...
    }
  ]
}
Fields
code

integer

The status code, which should be an enum value of google.rpc.Code.

message

string

A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.

details[]

object

A list of messages that carry the error details. There is a common set of message types for APIs to use.

An object containing fields of an arbitrary type. An additional field "@type" contains a URI identifying the type. Example: { "id": 1234, "@type": "types.example.com/standard/id" }.

Any

JSON representation
{
  "typeUrl": string,
  "value": string
}
Fields
typeUrl

string

Identifies the type of the serialized Protobuf message with a URI reference consisting of a prefix ending in a slash and the fully-qualified type name.

Example: type.googleapis.com/google.protobuf.StringValue

This string must contain at least one / character, and the content after the last / must be the fully-qualified name of the type in canonical form, without a leading dot. Do not write a scheme on these URI references so that clients do not attempt to contact them.

The prefix is arbitrary and Protobuf implementations are expected to simply strip off everything up to and including the last / to identify the type. type.googleapis.com/ is a common default prefix that some legacy implementations require. This prefix does not indicate the origin of the type, and URIs containing it are not expected to respond to any requests.

All type URL strings must be legal URI references with the additional restriction (for the text format) that the content of the reference must consist only of alphanumeric characters, percent-encoded escapes, and characters in the following set (not including the outer backticks): /-.~_!$&()*+,;=. Despite our allowing percent encodings, implementations should not unescape them to prevent confusion with existing parsers. For example, type.googleapis.com%2FFoo should be rejected.

In the original design of Any, the possibility of launching a type resolution service at these type URLs was considered but Protobuf never implemented one and considers contacting these URLs to be problematic and a potential security issue. Do not attempt to contact type URLs.

value

string (bytes format)

Holds a Protobuf serialization of the type described by type_url.

A base64-encoded string.

CloudSqlInstanceBackupPlanAssociationProperties

JSON representation
{
  "instanceCreateTime": string
}
Fields
instanceCreateTime

string (Timestamp format)

Output only. The time when the instance was created.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

FilestoreInstanceBackupPlanAssociationProperties

JSON representation
{
  "instanceCreateTime": string
}
Fields
instanceCreateTime

string (Timestamp format)

Output only. The time when the instance was created.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

AlloyDBClusterBackupPlanAssociationProperties

JSON representation
{
  "clusterUid": string
}
Fields
clusterUid

string

Output only. The cluster UID of the AlloyDB cluster.

State

Enum for State of BackupPlan Association

Enums
STATE_UNSPECIFIED State not set.
CREATING The resource is being created.
ACTIVE The resource has been created and is fully usable.
DELETING The resource is being deleted.
INACTIVE The resource has been created but is not usable.
UPDATING The resource is being updated.

LastBackupState

Enum for LastBackupState

Enums
LAST_BACKUP_STATE_UNSPECIFIED State not set.
FIRST_BACKUP_PENDING The first backup is pending.
PERMISSION_DENIED The most recent backup could not be run/failed because of the lack of permissions.
SUCCEEDED The last backup operation succeeded.
FAILED The last backup operation failed.

Tool Annotations

Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ✅ | Open World Hint: ❌